﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AutoFocusClientTester
{
    public partial class AutoFocusClientTesterForm : Form
    {
        dynamic _autofocus;

        public AutoFocusClientTesterForm()
        {
            InitializeComponent();
        }

        private void TryOrShowError(Action func)
        {
            try {
                func();
            }
            catch (Exception ex) {
                MessageBox.Show(ex.ToString());
            }
        }

        private void buttonCreateInstance_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                Type autofocusType = System.Type.GetTypeFromProgID("PlaneWave.AutoFocus");
                _autofocus = System.Activator.CreateInstance(autofocusType);
                tableLayout1.Enabled = true;
                tableLayout2.Enabled = true;
            });
        }

        private void buttonGetVersion_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericVersion.Value = _autofocus.Version;
            });
        }

        private void buttonGetFocusServer_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxFocusServer.Text = _autofocus.FocusServer;
            });
        }

        private void buttonGetHost_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxHost.Text = _autofocus.Host;
            });
        }

        private void buttonGetPort_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericPort.Value= _autofocus.Port;
            });
        }

        private void buttonGetServerTimeoutMilliseconds_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericServerTimeoutMilliseconds.Value = _autofocus.ServerTimeoutMilliseconds;
            });
        }

        private void buttonGetIsPwiResponding_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxIsPwiResponding.Text = _autofocus.IsPwiResponding.ToString();
            });
        }

        private void buttonGetIsFocuserConnected_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxIsFocuserConnected.Text = _autofocus.IsFocuserConnected.ToString();
            });
        }

        private void buttonGetExposureLengthSeconds_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericExposureLengthSeconds.Value = (decimal)_autofocus.ExposureLengthSeconds;
            });
        }

        private void buttonGetPreventFilterChange_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                checkBoxPreventFilterChange.Checked = _autofocus.PreventFilterChange;
            });
        }

        private void buttonGetIsAutofocusRunning_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxIsAutofocusRunning.Text = _autofocus.IsAutofocusRunning.ToString();
            });
        }

        private void buttonGetIsAutofocusDesired_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxIsAutofocusDesired.Text = _autofocus.IsAutofocusDesired.ToString();
            });
        }

        private void buttonGetSuccess_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxSuccess.Text = _autofocus.Success.ToString();
            });
        }

        private void buttonGetBestPosition_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericBestPosition.Value = _autofocus.BestPosition;
            });
        }

        private void buttonGetTolerance_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericTolerance.Value = (decimal)_autofocus.Tolerance;
            });
        }

        private void buttonGetNextLogMessage_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                string message = _autofocus.NextLogMessage;
                if (message == null) {
                    textBoxNextLogMessage.Text = "null";
                }
                else {
                    textBoxNextLogMessage.Text = message;
                }
            });
        }

        private void buttonGetIsFocuserMoving_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxIsFocuserMoving.Text = _autofocus.IsFocuserMoving.ToString();
            });
        }

        private void buttonGetFocuserPosition_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                numericFocusPosition.Value = (decimal)_autofocus.FocuserPosition;
            });
        }

        private void buttonSetFocusServer_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.FocusServer = textBoxFocusServer.Text;
            });
        }

        private void buttonSetHost_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.Host = textBoxHost.Text;
            });
        }

        private void buttonSetPort_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.Port = (int)numericPort.Value;
            });
        }

        private void buttonSetServerTimeoutMilliseconds_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.ServerTimeoutMilliseconds = (int)numericServerTimeoutMilliseconds.Value;
            });
        }

        private void buttonSetExposureLengthSeconds_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.ExposureLengthSeconds = (double)numericExposureLengthSeconds.Value;
            });
        }

        private void buttonSetPreventFilterChange_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.PreventFilterChange = checkBoxPreventFilterChange.Checked;
            });
        }

        private void buttonStartPwiIfNeeded_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.StartPwiIfNeeded();
            });
        }

        private void buttonConnectFocuser_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.ConnectFocuser();
            });
        }

        private void buttonStartAutofocus_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.StartAutofocus();
            });
        }

        private void buttonStopAutofocus_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.StopAutofocus();
            });
        }

        private void buttonMoveFocuser_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                _autofocus.MoveFocuser((double)numericTargetPosition.Value);
            });
        }

        private void buttonGetTemperatureNames_Click(object sender, EventArgs e)
        {
            textBoxTemperatureNames.Clear();

            TryOrShowError(() => {
                string[] names = _autofocus.TemperatureNames;
                foreach (string name in names) {
                    textBoxTemperatureNames.AppendText(name + Environment.NewLine);
                }
            });
        }

        private void buttonGetTemperatureByName_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                textBoxTemperatureValue.Text = _autofocus.GetTemperatureByName(textBoxTemperatureName.Text).ToString();
            });
        }

        private void buttonGetAllTemperatures_Click(object sender, EventArgs e)
        {
            textBoxAllTemperatures.Clear();
            TryOrShowError(() => {
                foreach (string temperatureName in _autofocus.TemperatureNames) {
                    double temperature = _autofocus.GetTemperatureByName(temperatureName);
                    textBoxAllTemperatures.AppendText(temperatureName + ": " + temperature + Environment.NewLine);
                }
            });
        }

        private void buttonGetPendingLogMessages_Click(object sender, EventArgs e)
        {
            TryOrShowError(() => {
                while (true) {
                    string message = _autofocus.NextLogMessage;
                    if (message == null) {
                        break;
                    }
                    textBoxLogMessages.AppendText(message + Environment.NewLine);
                }
            });
        }
    }
}
